unit DLLTest1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

// Prototypes for all routines in the DLL which will be called
// from a C++ program(!) later.
// All these are POINTERS because the DLL is loaded 'dynamically',
// and the application has to find all required addresses in the DLL
// itself (using the GetProcAddress()-function of Windows).
// Note that the calling convention is 'stdcall',
// not 'pascal' or 'cdecl'. This prevents name-mangling etc.
type T_GetParamString = function(param_nr:longint):PChar; stdcall;



type
  TDLLTestForm = class(TForm)
    Lab_DllFile: TLabel;
    Ed_DllFileName: TEdit;
    Btn_Load: TButton;
    Memo_Messages: TMemo;
    procedure Btn_LoadClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DLLTestForm: TDLLTestForm;

implementation

{$R *.DFM}

procedure TDLLTestForm.Btn_LoadClick(Sender: TObject);

  var dll_handle : longint;
      pGetParamString : pointer;
      pchr : PChar;


begin
   dll_handle := LoadLibrary(PChar(Ed_DllFileName.Text));
   if (dll_handle <> 0) then
    begin
      pGetParamString := GetProcAddress(dll_handle, '_DIGM_GetParamString' );
      if (pGetParamString = nil) then  // TRY AGAIN WITHOUT THE C-underscore
        pGetParamString := GetProcAddress(dll_handle, 'DIGM_GetParamString' );
      if (pGetParamString = nil) then  // try again with all lower case letters
        pGetParamString := GetProcAddress(dll_handle, 'digm_getparamstring' );

      if (pGetParamString <> nil) then
       begin
         // Try to call a few routines in the DLL which has just been loaded. 
         pchr := T_GetParamString(pGetParamString)(0);
         Memo_Messages.Lines.Add( pchr );
         pchr := T_GetParamString(pGetParamString)(1);
         Memo_Messages.Lines.Add( pchr );
       end
      else // address of DIGM_GetParamString could not be found
       begin
        ShowMessage('Could not locate address in DLL');
       end;
    end
   else
    begin
      ShowMessage('Could not load library');
    end;


end;

end.
