//---------------------------------------------------------------------------//
// DLL Skeleton for the implementation of new transmission modes in DELPHI.  //
// Compilation of this file gives a DLL which can be dynamically linked      //
//   into DL4YHF's Spectrum Laboratory.                                      //
// Details about the DLL skeleton can be found on the author's homepage at:  //
//   www.qsl.net/dl4yhf .                                                    //
//                                                                           //
//---------------------------------------------------------------------------//


library DemoDLL;

{ Important note about DLL memory management:
  To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters.
  DO NOT USE ANY VCL OBJECTS IN THIS DLL !
 }

 // I strongly recommend that you only put the 'interface'
 // from the DLL to the implementation of your digital trans-
 // mission mode in this file.
 // The 'real workers' should be placed in a separated module.
 //
 // More info on writing DLLs with DELPHI 4 can be found by
 // pressing F1 with the cursor in the keyword >library<,
 // 'Writing DLLs' from the Object Pascal reference.

uses
  SysUtils,
  Classes;

//--------------------------------------------------------------------------
function DIGM_GetParamString( param_nr:longint) : PChar; stdcall;
  // Exported function which returns STRINGS.
  // Input parameter:
  //   param_nr  defines which string shall be returned.
  //             Not implemented parameters may return NULL/nil
  //             or a dummy string. See case-list below.
  //  Return value:
  //    pointer to a null-terminated string (a 'PChar' in Delphi).
  //
begin
   case param_nr of
     0: // DLL information string #1 : WHAT is this digimode ?
         DIGM_GetParamString := 'Digimode-Demo-DLL in DELPHI';
     1: // DLL information string #2 : copyright and author
         DIGM_GetParamString := 'by Wolfgang Buescher, DL4YHF';
     2: // DLL compilation date / version string
         DIGM_GetParamString := 'March 10, 2001';
     else  // unsupported parameter number
         DIGM_GetParamString := 'unknown param_nr';
   end; // case param_nr
end;   // end DIGM_GetParamString()

exports
  DIGM_GetParamString;


begin   // library initialization code
end.
